@echo off
REM ######################################################################
REM #  Copyright (c) 2004, 2012, Oracle and/or its affiliates. All rights reserved.
REM #  billi      10/10/12  Fix Bug #14747584,#14747421
REM #  vganesan   9/10/12   Fix help in opatchauto.bat
REM #  billi      9/11/12   ReMap the CLI for RUP5 and tune it.
REM #  fisong     5/16/12   Initial Creation
REM ######################################################################

setlocal enabledelayedexpansion

REM # Set the base path
set BASE=%~DP0%

set OP=%1

set deployOpt=0

set getDeploy=0

set undeployOpt=0

set getUndeploy=0

set deployPatchLoc=

set helpOpt=0

set preOpt=0

set OPATCH_ARGS=

REM # Set invoke flag for opatchauto script
set OPATCH_AUTO_CALL=true

REM # Look for OPATCH_DEBUG env variable
set DEBUG=%OPATCH_DEBUG%

REM # Check for OPATCH_DEBUG
set DEBUGVAL=false
if "%DEBUG%" == "TRUE" (set DEBUGVAL=true) else if "%DEBUG%" == "true" (set DEBUGVAL=true) 

set PARAMS=%*
set PARAMS=%PARAMS% 

shift

set EXTRA_PARAMS=

:FORLOOP
if "%1" == "" goto DONELOOP

:CHECK1
if NOT "%1" == "-h" goto CHECK2
    set helpOpt=1
    goto DONELOOP

:CHECK2
if NOT "%1" == "-help" goto CHECK3
    set helpOpt=1
    goto DONELOOP

:CHECK3
if NOT "%1" == "-deploy" goto CHECK4
	set deployOpt=1
	shift
	goto FORLOOP

:CHECK4
if NOT "%1" == "-undeploy" goto FORCHECK
	set undeployOpt=1
	shift
	goto FORLOOP

:FORCHECK
set EXTRA_PARAMS=%EXTRA_PARAMS% %1
shift
goto FORLOOP

:DONELOOP
set PREFIX=
if NOT "%OP%" == "-h" goto HELP
    set "LASTCHAR=%PARAMS:~-1%"
    set "PARAMS=%PARAMS:~2,-1%"
    set PARAMS=%PARAMS%%LASTCHAR%
    set PREFIX="-h"
    goto EXECUTEOPATCHCOMMAND

:HELP
if NOT "%OP%" == "-help" goto APPLY
    set "LASTCHAR=%PARAMS:~-1%"
    set "PARAMS=%PARAMS:~5,-1%"
    set PARAMS=%PARAMS%%LASTCHAR%
    set PREFIX="-help"
    goto EXECUTEOPATCHCOMMAND

:APPLY
if NOT "%OP%" == "apply" goto ROLLBACK
    set "LASTCHAR=%PARAMS:~-1%"
    set "PARAMS=%PARAMS:~5,-1%"
    set PARAMS=%PARAMS%%LASTCHAR%
    if "%deployOpt%" == "1" (set PARAMS=%EXTRA_PARAMS%)
    if "%deployOpt%" == "0" (set PREFIX=apply -auto) else if "%deployOpt%" == "1" (set PREFIX=deploy)
    goto EXECUTEOPATCHCOMMAND

:ROLLBACK
if NOT "%OP%" == "rollback" goto LSPATCHES
    set "LASTCHAR=%PARAMS:~-1%"
    set "PARAMS=%PARAMS:~8,-1%"
    set PARAMS=%PARAMS%%LASTCHAR%
    if "%undeployOpt%" == "1" (set PARAMS=%EXTRA_PARAMS%)
    if "%undeployOpt%" == "0" (set PREFIX=rollback -auto) else if "%undeployOpt%" == "1" (set PREFIX=undeploy)
    goto EXECUTEOPATCHCOMMAND

:LSPATCHES
if NOT "%OP%" == "lspatches" goto SAVECONFIGURATIONSNAPSHOT
    set "LASTCHAR=%PARAMS:~-1%"
    set "PARAMS=%PARAMS:~9,-1%"
    set PARAMS=%PARAMS%%LASTCHAR%
    set PREFIX=lspatches -all
    goto EXECUTEOPATCHCOMMAND

:SAVECONFIGURATIONSNAPSHOT
if NOT "%OP%" == "saveConfigurationSnapshot" goto VERSION
    set "LASTCHAR=%PARAMS:~-1%"
    set "PARAMS=%PARAMS:~25,-1%"
    set PARAMS=%PARAMS%%LASTCHAR%
    set PREFIX=saveconfigurationsnapshot
    goto EXECUTEOPATCHCOMMAND

:VERSION
if NOT "%OP%" == "version" goto COMMIT
    set "LASTCHAR=%PARAMS:~-1%"
    set "PARAMS=%PARAMS:~7,-1%"
    set PARAMS=%PARAMS%%LASTCHAR%
    set PREFIX=version
    goto EXECUTEOPATCHCOMMAND

:COMMIT
if NOT "%OP%" == "commit" goto CHECKAPPLICABLE
    set "LASTCHAR=%PARAMS:~-1%"
    set "PARAMS=%PARAMS:~6,-1%"
    set PARAMS=%PARAMS%%LASTCHAR%
    set PREFIX=commit
    goto EXECUTEOPATCHCOMMAND

:CHECKAPPLICABLE
if NOT "%OP%" == "checkApplicable" goto OPTIONERROR
    set "LASTCHAR=%PARAMS:~-1%"
    set "PARAMS=%PARAMS:~15,-1%"
    set PARAMS=%PARAMS%%LASTCHAR%
    set PREFIX=prereq
    goto EXECUTEOPATCHCOMMAND

:OPTIONERROR
if "%OP%"=="" goto ERRORLEVELOR
    echo Syntax Error... Unrecognized Command %OP%
    echo Please run opatchauto -help to get more details
    set ERRORLEVEL=1
    goto OPATCHAUTODONE

:ERRORLEVELOR
    echo Syntax Error... No Command specified.
    echo Please run opatchauto -help to get more details
    set ERRORLEVEL=1
    goto OPATCHAUTODONE

:EXECUTEOPATCHCOMMAND
if %helpOpt% == 1 (set OPATCH_ARGS=%PREFIX%%PARAMS% -help) else (set OPATCH_ARGS=%PREFIX%%PARAMS%) 

%BASE%\opatch.bat %OPATCH_ARGS% -opatchautoscript

:OPATCHAUTODONE
set RESULT=%ERRORLEVEL%
if %ERRORLEVEL% == 0 goto SUCCEXIT
if NOT %ERRORLEVEL% ==0  goto FAILEXIT

:FAILEXIT
echo.
echo opatchauto failed with error code = %RESULT%
goto EXIT

:SUCCEXIT
echo.
echo opatchauto succeeded.
goto EXIT

:EXIT
exit /b %RESULT%
