@echo off
REM ######################################################################
REM #  Copyright (c) 2013 Oracle Corporation.  All rights reserved.
REM #  
REM #  billi    05/30/13   Support environment ORACLE_HOME
REM #  billi    03/11/13   Create and support -oh, -location
REM ######################################################################

setlocal enabledelayedexpansion

@REM determine the location of this script
set base=%~dp0
for %%i in ("%base%") do set base=%%~fsi

REM # set the base path and binary name
set OH=%ORACLE_HOME%
set LOCATION=
set getOH=0
set getLocation=0
set getHelp=0

if "%1" == "" (set getHelp=1)

:FORLOOP
if "%1" == "" goto DONELOOP
if not "%getHelp%" == "1" goto OH
	goto DONELOOP
:OH
if not "%getOH%" == "1" goto LOCATION
	set OH=%1
	set getOH=0
:LOCATION
if not "%getLocation%" == "1" goto SETOH
	set LOCATION=%1
	set getLocation=0
:SETOH
if not "%1" == "-oh" goto SETLOCATION
	set getOH=1
:SETLOCATION
if not "%1" == "-location" goto SETHELP
	set getLocation=1
:SETHELP
if not "%1" == "-help" goto FORCHECK
	set getHelp=1
:FORCHECK
	shift
	goto FORLOOP
:DONELOOP

if "%getHelp%" == "1" (
	echo Usage:	
	echo       createkeys.bat [-help]
	echo       createkeys.bat -oh [OMS Platform home] -location [location to store the config and key files]
	echo                      -oh       OMS Platform home path
	echo                      -location Location to store the configuration and key files
	exit /b 0
)

REM # remove quotes
REM set OH=%OH:%"=%
if NOT EXIST %OH%\NUL  (
	echo ERROR: Invalid home. Please check and pass OMS platform home to -oh parameter.
	goto SET_RC
)

if NOT EXIST %LOCATION%\NUL  (
	echo ERROR: Invalid location. Please check location input and try again.
	goto SET_RC
)
for %%i in ("%LOCATION%\..") do set LOCATION=%%~fsi

@REM SET MW_HOME
set MW_HOME=
set SCRIPTPATH=
set WLST_HOME=

if not exist %OH%\bin\emcli.bat goto ERROMS
    for %%i in ("%OH%\..") do set MW_HOME=%%~fsi
	set WLST_HOME=%OH%\common\wlst
	set SCRIPTPATH=%OH%\common\bin
	goto CHECK	
:ERROMS
	echo ERROR: Invalid home. Please check and pass OMS platform home to -oh parameter.
	goto SET_RC

@REM check
:CHECK
if not exist %MW_HOME%\registry.dat (
	echo ERROR: Invalid home. Please check and pass OMS platform home to -oh parameter.
	goto SET_RC
)
@REM set the home directories...
if exist %SCRIPTPATH%\setHomeDirs.cmd call %SCRIPTPATH%\setHomeDirs.cmd
@REM set the WLST extended env...
if exist %SCRIPTPATH%\setWlstEnv.cmd call %SCRIPTPATH%\setWlstEnv.cmd

@REM append additional jar files to the CLASSPATH...
if exist %WLST_HOME%\lib for %%g in (%WLST_HOME%\lib\*.jar) do (call :APPEND_CLASSPATH %%~fsg)

@REM append additional resource bundles to the CLASSPATH...
if exist %WLST_HOME%\resources for %%g in (%WLST_HOME%\resources\*.jar) do (call :APPEND_CLASSPATH %%~fsg)

@REM 
if exist %WL_HOME%\server\bin\setWLSEnv.cmd call %WL_HOME%\server\bin\setWLSEnv.cmd

if NOT "%WLST_HOME%"=="" (
  set WLST_PROPERTIES=-Dweblogic.wlstHome=%WLST_HOME% %WLST_PROPERTIES%
)

SET CLASSPATH=%CLASSPATH%;%FMWLAUNCH_CLASSPATH%;%DERBY_CLASSPATH%;%DERBY_TOOLS%

SET JVM_ARGS=-Dprod.props.file="%WL_HOME%\.product.properties" %WLST_PROPERTIES% %MEM_ARGS% %CONFIG_JVM_ARGS%

@REM accept weblogic management username and password
set username=
set password=
set/p username=Please enter weblogic admin server username:
set/p password=Please enter weblogic admin server password:

IF EXIST %JAVA_HOME% (
 "%JAVA_HOME%\bin\java" %JVM_ARGS% -Dweblogic.management.confirmKeyfileCreation=true weblogic.Admin -username %username% -password %password% -userconfigfile %LOCATION%\config -userkeyfile %LOCATION%\key STOREUSERCONFIG
) ELSE (
  CALL :SET_RC 1
)

echo User configuration file created: %LOCATION%\config
echo User key file created: %LOCATION%\key
echo 'createKeys.bat' succeeded.

SET RETURN_CODE=%ERRORLEVEL%

IF DEFINED USE_CMD_EXIT (
  EXIT %RETURN_CODE%
) ELSE (
  EXIT /B %RETURN_CODE%
)

:SET_RC
EXIT /B %1

:APPEND_CLASSPATH
set CLASSPATH=%CLASSPATH%;%1
